io.undertow.security.api

## Interface SessionNonceManager

All Superinterfaces:
  NonceManager

All Known Implementing Classes:
  SimpleNonceManager

    public interface SessionNonceManager
    extends NonceManager

An extension to the `NonceManager` interface for Nonce managers that also support the association of a pre-prepared hash against a currently valid nonce. If the nonce manager replaces in-use nonces as old ones expire then the associated session hash should be migrated to the replacement nonce.

Author:
  Darran Lofthouse

### Method Summary

All Methods Instance Methods Abstract Methods
`void` `associateHash(String nonce, byte[] hash)` Associate the supplied hash with the nonce specified.
`byte[]` `lookupHash(String nonce)` Retrieve the existing hash associated with the nonce specified.

### Methods inherited from interface io.undertow.security.api.NonceManager

`nextNonce, validateNonce`

### Method Detail

#### associateHash

    void associateHash(String nonce,
                       byte[] hash)

Associate the supplied hash with the nonce specified.

Parameters:
  `nonce` - - The nonce the hash is to be associated with.
  `hash` - - The hash to associate.

#### lookupHash

    byte[] lookupHash(String nonce)

Retrieve the existing hash associated with the nonce specified. If there is no association then null should be returned.

Parameters:
  `nonce` - - The nonce the hash is required for.
Returns:
  The associated hash or null if there is no association.